//------------------------------------------
#define maxH 50         //  
#define cap_time 3      //     
#define open_angle 10   //  
#define close_angle 155 //  

#define debug 0         //       (0 , 1 )
//------------------------------------------

// ------
#define trigPin 3
#define echoPin 2
#define sensorVCC 4
#define MOSFETpin 6
#define servoPin 5
// ------

#include "LowPower.h" //  
#include <Servo.h>    //      
Servo servo;          //   servo  Servo

long duration;
byte distance;
unsigned long open_timer;
boolean open_flag;

void setup() {
  Serial.begin(9600);
  if (debug) Serial.println("system start");
  servo.attach(servoPin);         //   5 
  pinMode(trigPin, OUTPUT);       //     
  digitalWrite(trigPin, 0);
  pinMode(MOSFETpin, OUTPUT);     //     
  digitalWrite(MOSFETpin, 0);
  pinMode(echoPin, INPUT);        //     

  pinMode(sensorVCC, OUTPUT);     //    
  digitalWrite(sensorVCC, 0);     //  

  open_cap();                     //    
}

void open_cap() {
  if (debug) Serial.println("open");
  digitalWrite(MOSFETpin, 1);     //    
  delay(1);
  servo.write(open_angle);        //  
  delay(1000);                    //  
  digitalWrite(MOSFETpin, 0);     //  
  open_flag = 1;                  //    
}
void close_cap() {
  if (debug) Serial.println("close");
  digitalWrite(MOSFETpin, 1);     //    
  delay(1);
  servo.write(close_angle);       //  
  delay(1000);                    //  
  digitalWrite(MOSFETpin, 0);     //  
  open_flag = 0;                  //    
}

void loop() {
  LowPower.powerDown(SLEEP_1S, ADC_OFF, BOD_OFF);  //  1 

  digitalWrite(sensorVCC, 1);           //  
  measure();                            //  "" ,    
  distance = measure();                 //  
  digitalWrite(sensorVCC, 0);           //  
  if (debug) {
    Serial.println(distance);
    delay(500);
  }  

  if (distance > 5 && distance < maxH){ //     
    open_timer = 0;                     //  
    if (!open_flag) {                   //   
      open_cap();                       //  
    }
  } else {
    if (open_flag) {                    //   
      open_timer++;                     //  
      if (open_timer > cap_time) {      //       5
        close_cap();                    //  
      }
    }

  }
}

// ,  
byte measure() {
  digitalWrite(trigPin, 0);
  delayMicroseconds(5);
  digitalWrite(trigPin, 1);
  delayMicroseconds(15);
  digitalWrite(trigPin, 0);
  duration = pulseIn(echoPin, HIGH);
  return (duration / 2) / 29.1;        //    
}